<template>
  <b-container>
    <b-row>
      <b-col>
        <h1>News</h1>
      </b-col>
    </b-row>
    <b-row>
      <b-col sm="4">
        <Sidebar>
          <Searchbar class="mb-4" @searched="onFilterChanged($event, 'searchTerm')" />
          <CategoriesSelector @categoriesChanged="onFilterChanged($event, 'categories')" />
        </Sidebar>
      </b-col>
      <b-col sm="8">
        <div v-if="!$apollo.loading && news.items.length">
          <div v-for="newItem in news.items" :key="newItem.id">
            <NewCard
              :slug="newItem.slug"
              class="mb-3"
              :title="newItem.title"
              :content="newItem.shortContent"
              :date="newItem.created"
              :image="newItem.image"
              :categories="newItem.categories"
            />
          </div>
        </div>
        <div v-else>
          No items found.
        </div>
        <b-pagination
          v-if="!$apollo.loading && news.count > filters.size"
          v-model="filters.currentPage"
          align="center"
          :total-rows="news.count"
          :per-page="5"
          @input="onPaginationChanged($event)"
        ></b-pagination>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import newsQuery from '@/graphql/news.query';
import Sidebar from '@/components/Sidebar.vue';
import CategoriesSelector from '@/components/CategoriesSelector.vue';
import NewCard from '@/components/NewCard.vue';
import Searchbar from '@/components/Searchbar.vue';

export default {
  components: {
    Sidebar,
    CategoriesSelector,
    NewCard,
    Searchbar,
  },
  data() {
    return {
      filters: {
        searchTerm: null,
        categories: null,
        from: 0,
        size: 5,
        currentPage: 1,
      },
    };
  },
  apollo: {
    news: {
      query: newsQuery,
      variables() {
        return {
          searchTerm: this.filters.searchTerm,
          categories: this.filters.categories,
          from: this.filters.from,
        };
      },
    },
  },
  methods: {
    onFilterChanged($event, filtername) {
      this.filters[filtername] = $event;
      this.$apollo.queries.news.refetch();
    },
    onPaginationChanged($event) {
      this.filters.currentPage = $event;
      this.onFilterChanged(this.filters.size * ($event - 1), 'from');
    },
  },
};
</script>
